var CC = CC || {};
(function(CC){
	
	
	//---------------------------------------------
	//--------------- UI & Interact----------------
	//---------------------------------------------
	
	function setDOMAttribute(dom, obj){
		for(let key in obj){
			if(typeof obj[key] == "object") setDOMAttribute(dom[key] = dom[key] || {},obj[key]);
			else dom[key] = obj[key];
		}
	}
	function createDOM(dom,obj,p){
		let ret = document.createElement(dom);
		setDOMAttribute(ret,obj);
		if(p) p.appendChild(ret);
		return ret;
	}
	let input = {
		value:"coco@",
		cols:40,
		rows:16,
		style:{
			resize:"none",
			backgroundColor:"black",
			color:"white",
			fontFamily:"Courier New",
			position:"fixed",
			right:"20px",
			bottom:"-500px",
			transition:"all 1s",
			fontSize:"14px",
			zIndex:5201314815
		}
	}
	let button = {
		innerHTML:"C",
		onmouseover:(e)=>{e.srcElement.style.backgroundColor = "#006dba";},
		onmouseout:(e)=>{e.srcElement.style.backgroundColor = "#50aaf8";},
		style:{
			userSelect:"none",
			cursor:"pointer",
			backgroundColor:"#50aaf8",
			color:"white",
			height:"50px",
			width:"50px",
			lineHeight:"50px",
			textAlign:"center",
			borderRadius:"50%",
			boxShadow:"#0088ff 1px 1px 10px",
			position:"fixed",
			right:"20px",
			bottom:"30px",
			transition:"all 1s",
			zIndex:5201314815
		}
	
	};
	button = createDOM("div",button,document.body);
	input = createDOM("textarea",input,document.body);
	button.onclick = ()=>{button.style.bottom="-500px";input.style.bottom="30px";}
	let doCommand = c=>{};
	input.onmousedown = function(){
		input.selectionStart = input.value.length;
		input.focus();
		return false;
	}
	
	input.onkeydown = function(e){
		if(e.keyCode == 13){ // Enter
			let start = input.value.lastIndexOf("@")+1;
			let end = input.value.length;
			let command = input.value.substr(start,end);
			command = command.split(" ").map(a=>a.trim()).filter(a=>a.length>0);
			
			if(command.length > 0 && "clear" == command[0]) input.value = "";
			else if(command.length > 0 && "hide" == command[0]) {input.style.bottom="-500px";button.style.bottom="30px";}
			else doCommand(command);
			
			input.value += "\ncoco@" 
			input.scrollTop = 9999999999999;
			
			return false;
		}else if(e.keyCode == 8){ // BackSpace
			if(input.value[input.value.length - 1] == "@") return false;
			if(input.value[input.selectionStart - 1] == "@") return false;
		}else if(e.keyCode == 37) {	// Left
			if(input.value[input.selectionStart - 1] == "@") return false;
		}else if(e.keyCode == 40){ // Down
			return false;
		}else if(e.keyCode == 38){ // Up
			return false;
		}
		console.log(e);
	}
	
	function setCommandHandler(h){doCommand = h;}
	function consoleValue(v){
		if(v)input.value = v;
		return input.value;
	}
	function outputAsNewLine(v){
		input.value += "\n" + v;
	}
	CC.webHelper = {
		"setCommandHandler" : setCommandHandler,
		"consoleValue":consoleValue,
		"outputAsNewLine":outputAsNewLine
	};
	
	
	document.body.appendChild(input);
	document.body.appendChild(button);

})(CC);

(function(CC){
	let commandsV1 = {};
	let println = out => CC.webHelper.outputAsNewLine(out);
	
	
	commandsV1["ls"] = function(){

		for(let i = 0 ; i < localStorage.length ;++i){
			println(localStorage.key(i));
		}
		
	}
	
	commandsV1["dump"] = function(type,to,all){
		let canDump = {
			"checkbox":"checked",
			"text": "value"
		};
		if(arguments.length < 2 || (arguments.length == 3 && all != "all") || !(type in canDump)){
			println("Usage: dump type to [all]");
			println("type 	: checkbox or text");
			println("to 	: config file name");
			println("all 	: all ");
			return false;
		}

		
		let attr = canDump[type];

		let obj = {"type":type,"attr":attr,"data":{}};

		let data = {};
		println("dump '"+type+"' '"+attr+"' to " + to);
		let doms = document.getElementsByTagName("input");
		for(let i = 0 ; i < doms.length ;++i){
			if(doms[i].type == type) {
				if(all) data[i] = doms[i][attr];
				else if(doms[i][attr]) data[i] = doms[i][attr];
			}
		}
		obj.data = data;
	
		
		
		
		localStorage.setItem(to,JSON.stringify(obj));
	}
	commandsV1["restore"] = function(from){
		if(arguments.length != 1){
			println("which file you want to restore?");
			return false;
		}
		try{
			if(!localStorage.getItem(from)){
				println("restore file format error.");
				return false;
			}
			let obj = JSON.parse(localStorage.getItem(from));
			let type = obj.type;
			let attr = obj.attr;
			let data = obj.data;
			if(type == type){
				println("restore '"+type+"' '"+attr+"' from " + from);
				let doms = document.getElementsByTagName("input");
				for(let i = 0 ; i < doms.length ;++i){
					if(doms[i].type == type&& i in data) doms[i][attr] = data[i];
				}
			}
		}catch(e){
			println("an exception occurred, restore terminated!");
		}
		
		
	}
	
	function dispatch(command){
		if(command.length > 0 && typeof commandsV1[command[0]] == "function"){
			let args = [] ;
			for(let i = 1 ; i < command.length ; ++i) args.push(command[i]);
			commandsV1[command[0]](...args);
		}else if(command.length > 0){
			println("no such command:" + command[0])
		}
	}
	CC.webHelper.setCommandHandler(dispatch);
	
})(CC);

